<template>
  <div>
    <h2>Sign Up:</h2>
    <div class="form-group sign_up_form">
      <p>
        <input
          id='user_email'
          type="text"
          placeholder="Email"
          class="form-control"
          v-model="email"
        />
      </p>
      <p>
        <input
          id='user_password'
          type="password"
          placeholder="Password"
          class="form-control"
          v-model="password"
        />
      </p>
      <p>
        <input
          id='user_password_confirmation'
          type="password"
          placeholder="Repeat password"
          class="form-control"
          v-model="password_confirmation"
        />
      </p> 
      <p style="color:red;"> {{password_message}} </p>
      <button id='sign_up_btn' class="btn btn-primary" @click='signUp'>Sign Up</button>

    </div>
    <p><router-link to="/sign_in">Sing In</router-link></p>
  </div>
</template>


<script>
  export default {
    data () {
      return {
        email: '',
        password: '',
        password_confirmation: '',
        password_message: '',
        logged: this.$store.state.logged
      }
    },
    methods: {
      validatePassword() {
        let isValid = this.password == this.password_confirmation
        if(isValid) {
          this.password_message = ''
        } else {
          this.password_message = 'Passwords must be the same!'
        }
        return isValid
      },
      signUp () {
        const url = '/api/v1/registrations'
        if(this.validatePassword()) {
          this.$http.post(url, { email: this.email, password: this.password }).then((response) => {
            this.$root.$emit('signInUser', {email: this.email, password: this.password })
            this.$root.$emit('setFlashMsg', {message: response.body.message, type: 'normal'})
          }).catch((error) => {
            this.$root.$emit('setFlashMsg', {message: error.body.message, type: 'error'})
          })
        }
      },
      checkUser() {
        this.email = this.$store.state.user.email
        if(this.$store.state.user.email) {
          this.$router.push('/')
        }
      }
    }
  }
</script>
